-- ZB_DM_JRQDJDMQBBF ZB_DM_今日签单季度末待起保保费
-- key:allquarterqdbf
-- 1、日期:核保日期或者核批完成日期(yyyyMMdd)
-- 2、起保时间小于等于当季度

--  总公司
insert into ZB_DM.ZB_DM_REDIS.SET_DECIMAL
select
    CONCAT(
            'allquarterqdbf/'
        ,s1.`uwConclueDate`
        )                                       as `key`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from ZB_ODS.ZB_ODS_KAFKA.CBDATA s1
where s1.`COMNAME` is not null
  and s1.`uwConclueDate` = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
-- 核保时间在今天并且起保时间的月份小于等于季度。
  and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
            END
group by
    s1.`uwConclueDate`
;

-- 分公司
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'provquarterqdbf/'
        ,s1.`uwConclueDate`
        )                                       as `key`
     ,s1.`LEVEL1COMCODE`                     as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from ZB_ODS.ZB_ODS_KAFKA.CBDATA s1
where s1.`COMNAME` is not null
  and s1.`uwConclueDate` = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
-- 核保时间在今天并且起保时间的月份小于等于季度。
  and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
            END
group by
     s1.`uwConclueDate`
    ,s1.`LEVEL1COMCODE`
;

-- 中支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'cityquarterqdbf/'
        ,s1.`uwConclueDate`
        )                                    as `key`
     ,s1.`LEVEL2COMCODE`                     as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from ZB_ODS.ZB_ODS_KAFKA.CBDATA s1
where s1.`COMNAME` is not null
  and s1.`uwConclueDate` = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
-- 核保时间在今天并且起保时间的月份小于等于季度。
  and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
            END
group by
    s1.`uwConclueDate`
    ,s1.`LEVEL2COMCODE`
;


-- 县支
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'countyquarterqdbf/'
        ,s1.`uwConclueDate`
        )                                    as `key`
     ,s1.`LEVEL3COMCODE`                     as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))  as `val`
from ZB_ODS.ZB_ODS_KAFKA.CBDATA s1
where s1.`COMNAME` is not null
  and s1.`uwConclueDate` = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
-- 核保时间在今天并且起保时间的月份小于等于季度。
  and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
            END
group by
    s1.`uwConclueDate`
    ,s1.`LEVEL3COMCODE`
;


-- 团队
insert into ZB_DM.ZB_DM_REDIS.HSET_DECIMAL
select
    CONCAT(
            'teamquarterqdbf/'
        ,s1.`uwConclueDate`
        )                                     as `key`
     ,s1.`LEVEL4COMCODE`                      as `hkey`
     ,sum(cast(s1.`cost` as DECIMAL(18,2)))   as `val`
from ZB_ODS.ZB_ODS_KAFKA.CBDATA s1
where s1.`COMNAME` is not null
  and s1.`uwConclueDate` = DATE_FORMAT(LOCALTIMESTAMP,'yyyyMMdd')
-- 核保时间在今天并且起保时间的月份小于等于季度。
  and CASE WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('01','02','03') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'03')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('04','05','06') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'06')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('07','08','09') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'09')
           WHEN DATE_FORMAT(LOCALTIMESTAMP,'MM') in ('10','11','12') THEN left(s1.`startTime`,6) <= CONCAT(DATE_FORMAT(LOCALTIMESTAMP,'yyyy'),'12')
            END
group by
    s1.`uwConclueDate`
   ,s1.`LEVEL4COMCODE`
;
